/******************************************************************************
Copyright 2018-2028 @
All Rights Reserved
FileName:    cnn.h
Description:
Author:		meimaokui@126.com
Date:		$(Time)
Modification History: <version>      <time>      <author>        <desc>
a)					  v1.0.0	   $(time)	  meimaokui@126.com	 Creat
******************************************************************************/
#ifndef _MMK_CNN_H_
#define _MMK_CNN_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
	//#include <random>
#include <time.h>
#include "mat.h"
#include "../inc/com_type_def.h"
#include "../inc/common.h"
#include "minst.h"

#define AvePool 0
#define MaxPool 1
#define MinPool 2

#define CNN_AVE_POOL	0
#define CNN_MAX_POOL	1
#define CNN_MIN_POOL	2

#define CNN_LAYER_NUM 5

#define CNN_LAYER1_IN_SIZE			28
#define CNN_MAP_SIZE				5
#define CNN_LAYER1_MAP_SIZE			5
#define CNN_LAYER1_IN_CHANNEL_NUM	1
#define CNN_LAYER1_OUT_CHANNEL_NUM	6
#define CNN_LAYER1_OUT_SIZE			24

#define CNN_LAYER2_IN_CHANNEL_NUM 6
#define CNN_LAYER2_OUT_CHANNEL_NUM 6
#define CNN_LAYER2_OUT_SIZE 12


#define CNN_LAYER3_IN_SIZE 12
#define CNN_LAYER3_MAP_SIZE 5
#define CNN_LAYER3_IN_CHANNEL_NUM 6
#define CNN_LAYER3_OUT_CHANNEL_NUM 12
#define CNN_LAYER3_OUT_SIZE 8

#define CNN_LAYER4_IN_CHANNEL_NUM 12
#define CNN_LAYER4_OUT_CHANNEL_NUM 12
#define CNN_LAYER4_OUT_SIZE 4

#define CNN_LAYER5_IN_CHANNEL_NUM 12
#define CNN_LAYER5_OUT_CHANNEL_NUM 10
#define CNN_LAYER5_IN_DATA_NUM (CNN_LAYER5_IN_CHANNEL_NUM * CNN_LAYER4_OUT_SIZE * CNN_LAYER4_OUT_SIZE)

#define CNN_DATA_FILE_DIR "/mnt/hgfs/share/cnnDemo/PicTrans/CNNData"


	/*  */
	typedef struct convolutional_layer
	{
		int inputWidth;   /* ͼĿ */
		int inputHeight;  /* ͼĳ */
		int mapSize;      /* ģĴСģһ㶼 */

		int inChannels;   /* ͼĿ */
		int outChannels;  /* ͼĿ */

		/*
		ģȨطֲһά,СΪinChannels*outChannels*mapSize*mapSizeС
		ά飬ҪΪ˱ȫӵʽʵϾ㲢ûõȫӵʽ
		DeapLearningToolbooxCNNӣõȫ
		*/
		float ****mapData;     /* ģ */
		float ****dmapData;    /* ģݵľֲݶ */

		float *basicData;   /* ƫãƫõĴСΪoutChannels */
		BOOL isFullConnect; /* ǷΪȫ */
		BOOL *connectModel; /* ģʽĬΪȫӣ */

		/* ߵĴСͬάͬ */
		float ***v; /* 뼤ֵ */
		float ***y; /* Ԫ */

		/* صľֲݶ */
		float ***d; /* ľֲݶ,ֵ */
	} CovLayer;

	// 
	typedef struct _CNN_COV_LAYER_L1_{
		int inputWidth;   //ͼĿ 28
		int inputHeight;  //ͼĳ 28
		int mapSize;      //ģĴСģһ㶼 5*5

		int inChannels;   //ͼĿ 1
		int outChannels;  //ͼĿ 6

		BOOL isFullConnect; //ǷΪȫ
		BOOL* connectModel; //ģʽĬΪȫӣ

		/*
		ģȨطֲһά,СΪinChannels*outChannels*mapSize*mapSizeС
		ά飬ҪΪ˱ȫӵʽʵϾ㲢ûõȫӵʽ
		DeapLearningToolbooxCNNӣõȫ
		*/
		//ģ
		float mapData[CNN_LAYER1_IN_CHANNEL_NUM][CNN_LAYER1_OUT_CHANNEL_NUM][CNN_LAYER1_MAP_SIZE][CNN_LAYER1_MAP_SIZE];
		//ģݵľֲݶ
		float dMapData[CNN_LAYER1_IN_CHANNEL_NUM][CNN_LAYER1_OUT_CHANNEL_NUM][CNN_LAYER1_MAP_SIZE][CNN_LAYER1_MAP_SIZE];
		//ƫãƫõĴСΪoutChannels
		float basicData[CNN_LAYER1_OUT_CHANNEL_NUM];

		// ߵĴСͬάͬ
		// 뼤ֵ
		float v[CNN_LAYER1_OUT_CHANNEL_NUM][CNN_LAYER1_OUT_SIZE][CNN_LAYER1_OUT_SIZE];
		// Ԫ
		float y[CNN_LAYER1_OUT_CHANNEL_NUM][CNN_LAYER1_OUT_SIZE][CNN_LAYER1_OUT_SIZE];
		// صľֲݶ, ľֲݶ,ֵ  
		float d[CNN_LAYER1_OUT_CHANNEL_NUM][CNN_LAYER1_OUT_SIZE][CNN_LAYER1_OUT_SIZE];

		float mapOut[CNN_LAYER1_OUT_SIZE][CNN_LAYER1_OUT_SIZE]; //žʱ

		//GPU
		float *vDev[CNN_LAYER1_OUT_CHANNEL_NUM];
		float *yDev[CNN_LAYER1_OUT_CHANNEL_NUM];
		float *dDev[CNN_LAYER1_OUT_CHANNEL_NUM];
		float *mapOutDev;
		float* basicDev;
	}CNN_COV_LAYER_L1;

	//  pooling ػ
	typedef struct _CNN_POOLING_LAYER_L2_{
		int inputWidth;   //ͼĿ 24
		int inputHeight;  //ͼĳ 24
		int mapSize;      //ģĴС 2*2

		int inChannels;   //ͼĿ 6
		int outChannels;  //ͼĿ 6

		int poolType;     //Poolingķ
		float basicData[CNN_LAYER2_OUT_CHANNEL_NUM];   //ƫ

		float y[CNN_LAYER2_OUT_CHANNEL_NUM][CNN_LAYER2_OUT_SIZE][CNN_LAYER2_OUT_SIZE]; // Ԫ,޼
		float d[CNN_LAYER2_OUT_CHANNEL_NUM][CNN_LAYER2_OUT_SIZE][CNN_LAYER2_OUT_SIZE]; // ľֲݶ,ֵ

		//##############################GPU###########################################//
		float * basicDev;
		float * yDev[CNN_LAYER2_OUT_CHANNEL_NUM];
		float * dDev;

	}CNN_POOLING_LAYER_L2;

	typedef struct _CNN_COV_LAYER_L3_{
		int inputWidth;   //ͼĿ 12
		int inputHeight;  //ͼĳ 12
		int mapSize;      //ģĴСģһ㶼 5*5

		int inChannels;   //ͼĿ 6
		int outChannels;  //ͼĿ 12

		BOOL isFullConnect; //ǷΪȫ
		BOOL* connectModel; //ģʽĬΪȫӣ
		//##############################CPU###########################################//
		/*
		ģȨطֲһά,СΪinChannels*outChannels*mapSize*mapSizeС
		ά飬ҪΪ˱ȫӵʽʵϾ㲢ûõȫӵʽ
		DeapLearningToolbooxCNNӣõȫ
		*/
		//ģ
		float mapData[CNN_LAYER3_IN_CHANNEL_NUM][CNN_LAYER3_OUT_CHANNEL_NUM][CNN_LAYER3_MAP_SIZE][CNN_LAYER3_MAP_SIZE];
		//ģݵľֲݶ
		float dMapData[CNN_LAYER3_IN_CHANNEL_NUM][CNN_LAYER3_OUT_CHANNEL_NUM][CNN_LAYER3_MAP_SIZE][CNN_LAYER3_MAP_SIZE];
		//ƫãƫõĴСΪoutChannels
		float basicData[CNN_LAYER3_OUT_CHANNEL_NUM];

		// ߵĴСͬάͬ
		// 뼤ֵ
		float v[CNN_LAYER3_OUT_CHANNEL_NUM][CNN_LAYER3_OUT_SIZE][CNN_LAYER3_OUT_SIZE];
		// Ԫ
		float y[CNN_LAYER3_OUT_CHANNEL_NUM][CNN_LAYER3_OUT_SIZE][CNN_LAYER3_OUT_SIZE];
		// صľֲݶ, ľֲݶ,ֵ  
		float d[CNN_LAYER3_OUT_CHANNEL_NUM][CNN_LAYER3_OUT_SIZE][CNN_LAYER3_OUT_SIZE];

		float mapOut[CNN_LAYER3_OUT_SIZE][CNN_LAYER3_OUT_SIZE]; //žʱ

		//##############################GPU###########################################//
		float *	basicDev;   //ƫãСΪoutputNumС
		float *mapOutDev;
		float *vDev[CNN_LAYER3_OUT_CHANNEL_NUM];
		float *yDev[CNN_LAYER3_OUT_CHANNEL_NUM];
		float *dDev[CNN_LAYER3_OUT_CHANNEL_NUM];


	}CNN_COV_LAYER_L3;


	//  pooling ػ
	typedef struct _CNN_POOLING_LAYER_L4_{
		int inputWidth;   //ͼĿ 8
		int inputHeight;  //ͼĳ 8
		int mapSize;      //ģĴС 2*2

		int inChannels;   //ͼĿ 12
		int outChannels;  //ͼĿ 12

		int poolType;     //Poolingķ
		//##############################CPU###########################################//
		float basicData[CNN_LAYER4_OUT_CHANNEL_NUM];   //ƫ

		float y[CNN_LAYER4_OUT_CHANNEL_NUM][CNN_LAYER4_OUT_SIZE][CNN_LAYER4_OUT_SIZE]; // Ԫ,޼
		float d[CNN_LAYER4_OUT_CHANNEL_NUM][CNN_LAYER4_OUT_SIZE][CNN_LAYER4_OUT_SIZE]; // ľֲݶ,ֵ

		//##############################GPU###########################################//
		float * basicDev;
		float * yDev;
		float * dDev;

	}CNN_POOLING_LAYER_L4;

	//  pooling
	typedef struct pooling_layer{
		int inputWidth;   //ͼĿ
		int inputHeight;  //ͼĳ
		int mapSize;      //ģĴС

		int inChannels;   /* ͼĿ */
		int outChannels;  /* ͼĿ */

		int poolType;     /* Poolingķ */
		float *basicData;   /* ƫ */

		float ***y; /* Ԫ,޼ */
		float ***d; /* ľֲݶ,ֵ */
	} PoolLayer;

	/*  ȫӵ */
	typedef struct nn_layer
	{
		int	inputNum;       /* ݵĿ */
		int	outputNum;      /* ݵĿ */

		float **wData; /* ȨݣΪһinputNum*outputNumС */
		float *basicData;    /* ƫãСΪoutputNumС */

		/* ߵĴСͬάͬ */
		float *v;  /* 뼤ֵ */
		float *y;  /* Ԫ */
		float *d;  /* ľֲݶ,ֵ */

		BOOL isFullConnect;    /* ǷΪȫ */
	} OutLayer;

	//  ȫӵ
	typedef struct _CNN_OUT_LAYER_L5_{
		int 	inputNum;   //ݵĿ 192
		int 	outputNum;  //ݵĿ 10
		BOOL 	isFullConnect; //ǷΪȫ
		//##############################CPU###########################################//
		float	inData[CNN_LAYER5_IN_DATA_NUM];//ǰתΪһά
		float 	wData[CNN_LAYER5_OUT_CHANNEL_NUM][CNN_LAYER5_IN_DATA_NUM]; // ȨݣΪһinputNum*outputNumС
		float 	basicData[CNN_LAYER5_OUT_CHANNEL_NUM];   //ƫãСΪoutputNumС

		// ߵĴСͬάͬ
		float 	v[CNN_LAYER5_OUT_CHANNEL_NUM]; // 뼤ֵ
		float 	y[CNN_LAYER5_OUT_CHANNEL_NUM]; // Ԫ
		float 	d[CNN_LAYER5_OUT_CHANNEL_NUM]; // ľֲݶ,ֵ

		//##############################GPU###########################################//
		float * inDev;//ǰתΪһά
		float * wDev;
		float *	basicDev;   //ƫãСΪoutputNumС
		float *	vDev; // 뼤ֵ
		float *	yDev; // Ԫ
		float *	dDev; // ľֲݶ,ֵ	
	}CNN_OUT_LAYER_L5;


	typedef struct cnn_net{
		int 		layerNum;
		CovLayer* 	C1;
		PoolLayer* 	S2;
		CovLayer* 	C3;
		PoolLayer* 	S4;
		OutLayer* 	O5;

		float *e;      /* ѵ */
		float *L;      /* ˲ʱ */
	} CNN;

	typedef struct _CNN_NET_STR_{
		int 		layerNum;
		float * pInDataDev;
		int 		res[2];
		CNN_COV_LAYER_L1 		stCovL1;
		CNN_POOLING_LAYER_L2 	stPoolL2;
		CNN_COV_LAYER_L3		stCovL3;
		CNN_POOLING_LAYER_L4	stPoolL4;
		CNN_OUT_LAYER_L5		stOutL5;

		float e[CNN_LAYER5_OUT_CHANNEL_NUM];      /* ѵ */
		float L[CNN_PIC_TRAIN_NUM];      /* ˲ʱ */
	} CNN_NET_STR;


	typedef struct train_opts
	{
		int	numepochs;         /* ѵĵ */
		float alpha;       /* ѧϰ */
	} CNNOpts;

	void cnnsetup(CNN *cnn, nSize inputSize, int outputSize);
	void CnnSetUp(CNN_NET_STR* stCnnNet);
	/*******************************************************************************
	Function:		CnnTrainProc
	Description:
	Input:
	Output:		N/A
	Return:		0:			Successful
	ohters:		Failed
	*******************************************************************************/
	void CnnTrainProc(CNN_NET_STR *pCnnNet, MinstImgArr *inputData, MinstLabelArr *outputData, CNNOpts opts, int trainNum);
	/*
	CNNѵ
	inputDataoutputDataֱѵ
	dataNumĿ
	*/
	void cnnTrain(CNN *cnn, MinstImgArr* inputData, MinstLabelArr* outputData, CNNOpts opts, int trainNum);

	/* cnn */
	float cnnTest(CNN *cnn, MinstImgArr* inputData, MinstLabelArr* outputData, unsigned int testNum);

	/* cnn */
	void savecnn(CNN *cnn, const char *filename);
	/* cnn */
	int importcnn(CNN *cnn, const char *filename);


	void SaveCnnModelFile(CNN_NET_STR* pCnnNet, const char* fileName);



	/* ʼ */
	CovLayer *initCovLayer(int inputWidth, int inputHeight, int mapSize, int inChannels, int outChannels);
	void CovLayerConnect(CovLayer *covL, BOOL *connectModel);

	/* ʼ */
	PoolLayer *initPoolLayer(int inputWidth, int inputHeigh, int mapSize, int inChannels, int outChannels, int poolType);
	void PoolLayerConnect(PoolLayer *poolL, BOOL *connectModel);

	/* ʼ */
	OutLayer *initOutLayer(int inputNum, int outputNum);

	/*  inputݣinputNum˵Ŀbasƫ */
	float activation_Sigma(float input, float bas); /* sigma */
	float SigmaActiveFun(float input, float bas); // sigma


	void cnnff(CNN *cnn, float **inputData); /* ǰ򴫲 */
	void CnnForwardPass(CNN_NET_STR* pCnnNet, float* inputData);
	void CnnBackPass(CNN_NET_STR *pCnnNet, float *outputData); /* ĺ򴫲 */

	void cnnbp(CNN *cnn, float *outputData); /* ĺ򴫲 */
	void cnnapplygrads(CNN *cnn, CNNOpts opts, float **inputData);
	void CnnApplyGrads(CNN_NET_STR *pCnnNet, CNNOpts opts, float *inputData); /* Ȩ */

	void cnnclear(CNN *cnn); /* vyd */
	/*******************************************************************************
	Function:		CnnParamClear
	Description:
	Input:
	Output:		N/A
	Return:		0:			Successful
	ohters:		Failed
	*******************************************************************************/
	void CnnParamClear(CNN_NET_STR *pCnnNet);

	/*
	Pooling Function
	input 
	inputNum Ŀ
	mapSize ƽģ
	*/
	void avgPooling(float **output, nSize outputSize, float **input, nSize inputSize, int mapSize); /* ƽֵ */
	void PoolingAverage(float* output, nSize outputSize, float* input, nSize inputSize, int mapSize);

	/*
	ȫĴ
	nnSizeĴС
	*/
	void nnff(float *output, float *input, float **wdata, float *bas, nSize nnSize); /* ȫǰ򴫲 */
	void nn2f(float* output, float* input, float* wdata, float* bas, nSize nnSize);

	void saveCnnData(CNN *cnn, const char *filename, float **inputdata); /* CNNе */
	void SaveCnnMidData(CNN_NET_STR *pCnnNet, const char *filename, float **inputdata);

	/*******************************************************************************
	Function:		CNNOptsPrint
	Description:
	Input:
	Output:		N/A
	Return:		0:			Successful
	ohters:		Failed
	*******************************************************************************/
	void CNNOptsPrint(CNNOpts *pCNNOpts);

	void CovLayerPrint(CovLayer *pCovLayer);
	void PoolLayerPrint(PoolLayer *pPoolLayer);
	void OutLayerPrint(OutLayer *pOutLayer);
	INT32 vecMaxIndex(PFLOAT vec, UINT32 veclength);

#ifdef __cplusplus
}
#endif

#endif
